#include "stdafx.h"
#include "color_group.h"

color_group::color_group() :
	color_size (0),
	colors (NULL)
{
}

color_group::~color_group()
{
	delete [] colors;
}

bool color_group::load (FILE* in, unsigned short num_colors, unsigned char bits)
{
	bool ret = false;
	color_size = num_colors;
	colors = new rgb [color_size];
	if (colors) {
		memset (colors, 0, color_size * sizeof (rgb));
		switch (bits) {
			case 24:
			// 24  
			ret = (color_size == fread (colors, 3, color_size, in));
			break;

			case 12:
			{
				// 12  
				unsigned short buf;
				for (unsigned short i = 0; i < color_size &&
					(ret = (1 == fread (&buf, 2, 1, in))) == true; i++) {
					colors [i].red = (unsigned char) ((buf /*<< 4*/) & 0xf0);
					colors [i].green = (unsigned char) ((buf >> 4) & 0xf0);
					colors [i].blue = (unsigned char) ((buf << 4) & 0xf0);
				}
			}
			break;
		}
	}
	return ret;
}
